﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MongoDB.Driver;
using System.Configuration;
using System.Text;
using MongoDB.Bson;
using MongoDB.Driver.Builders;
using System.Diagnostics;

namespace MvcApplication1.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            var testTable = GetDB()["testTable"].FindAll();
            return View(testTable);
        }

        //
        // GET: /Home/Details/5

        public ActionResult Details(string id)
        {
            try
            {
                var db = GetDB();
                var doc = db["testTable"].Find(Query.EQ("_id", new BsonObjectId(id))).First();                
                return View(doc);
            }
            catch
            {
                return View();
            }            
        }

        //
        // GET: /Home/Create

        public ActionResult Create()
        {
            return View();
        }

        //
        // POST: /Home/Create

        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                var db = GetDB();
                var doc = new BsonDocument();

                foreach (var key in collection.AllKeys)
                {
                    doc.Add(new BsonElement(key, collection[key]));
                }

                db["testTable"].Insert(doc);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Home/Edit/5

        public ActionResult Edit(string id)
        {
            var db = GetDB();
            var doc = db["testTable"].Find(Query.EQ("_id", new BsonObjectId(id))).First();
            return View(doc);
        }

        //
        // POST: /Home/Edit/5

        [HttpPost]
        public ActionResult Edit(string id, FormCollection collection)
        {
            try
            {
                var db = GetDB();
                var update = new UpdateBuilder();
                foreach (string key in collection.Keys)
                {
                    update.Set(key, collection[key]);
                }

                db["testTable"].Update(Query.EQ("_id", new BsonObjectId(id)), update);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Home/Delete/5

        public ActionResult Delete(string id)
        {
            try
            {
                var db = GetDB();
                db["testTable"].Remove(Query.EQ("_id", new BsonObjectId(id)));
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // POST: /Home/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        private MongoDatabase GetDB()
        {
            return MongoDatabase.Create(ConfigurationManager.ConnectionStrings["MongoDB"].ConnectionString);
        }

    }
}
